<?php
if (!defined('ABSPATH'))
    exit;

class CBB_admin
{

    /**
     * The single instance
     * @var    object
     * @access  private
     * @since    1.0.0
     */
    private static $_instance = null;

    /**
     * The main plugin object.
     * @var    object
     * @access  public
     * @since    1.0.0
     */
    public $parent = null;

    /**
     * Prefix for plugin settings.
     * @var     string
     * @access  publicexport
     * Delete
     * @since   1.0.0
     */
    public $base = '';

    /**
     * Available settings for plugin.
     * @var     array
     * @access  public
     * @since   1.0.0
     */
    public $settings = array();

    /**
     * Is WooCommerce activated ?
     * @var     array
     * @access  public
     * @since   1.5.0
     */
    public $isWooEnabled = false;

    public function __construct($parent)
    {
        $this->parent = $parent;
        $this->base = 'cbb_';
        $this->dir = dirname($this->parent->file);
        chmod(plugin_dir_path(__FILE__) . '../assets/picsLibrary', 0747);
        chmod(plugin_dir_path(__FILE__) . '../assets/depthImgs', 0747);
        
        add_action('admin_menu', array($this, 'add_menu_item'));
        add_action('admin_print_scripts', array($this, 'admin_scripts'));
        add_action('admin_print_styles', array($this, 'admin_styles'));
        add_action('wp_ajax_nopriv_cbb_addBanner', array($this, 'addBanner'));
        add_action('wp_ajax_cbb_addBanner', array($this, 'addBanner'));
        add_action('wp_ajax_nopriv_cbb_loadBanner', array($this, 'loadBanner'));
        add_action('wp_ajax_cbb_loadBanner', array($this, 'loadBanner'));
        add_action('wp_ajax_nopriv_cbb_removeBanner', array($this, 'removeBanner'));
        add_action('wp_ajax_cbb_removeBanner', array($this, 'removeBanner'));
        add_action('wp_ajax_nopriv_cbb_uploadPicture', array($this, 'upload_picture'));
        add_action('wp_ajax_cbb_uploadPicture', array($this, 'upload_picture'));
        add_action('wp_ajax_nopriv_cbb_saveObject', array($this, 'saveObject'));
        add_action('wp_ajax_cbb_saveObject', array($this, 'saveObject'));
        add_action('wp_ajax_nopriv_cbb_saveBanner', array($this, 'saveBanner'));
        add_action('wp_ajax_cbb_saveBanner', array($this, 'saveBanner'));
        add_action('wp_ajax_nopriv_cbb_exportBanners', array($this, 'exportBanners'));
        add_action('wp_ajax_cbb_exportBanners', array($this, 'exportBanners'));
        add_action('wp_ajax_nopriv_cbb_importBanners', array($this, 'importBanners'));
        add_action('wp_ajax_cbb_importBanners', array($this, 'importBanners'));
        add_action('wp_ajax_nopriv_cbb_duplicateBanner', array($this, 'duplicateBanner'));
        add_action('wp_ajax_cbb_duplicateBanner', array($this, 'duplicateBanner'));              
        add_action('wp_ajax_nopriv_cbb_getSprites', array($this, 'getSprites'));
        add_action('wp_ajax_cbb_getSprites', array($this, 'getSprites'));                 
        add_action('wp_ajax_nopriv_cbb_delPic', array($this, 'delPic'));
        add_action('wp_ajax_cbb_delPic', array($this, 'delPic'));          
        add_action('wp_ajax_nopriv_cbb_changeBannerTitle', array($this, 'changeBannerTitle'));
        add_action('wp_ajax_cbb_changeBannerTitle', array($this, 'changeBannerTitle'));
        add_action('wp_ajax_nopriv_cbb_saveDomElement', array($this, 'saveDomElement'));
        add_action('wp_ajax_cbb_saveDomElement', array($this, 'saveDomElement'));    
                     
        add_action('vc_before_init', array($this, 'init_vc'));

    }
    
     /*
    *  Add shortcode to VisualComposer
    */
    public function init_vc(){
       if (defined( 'WPB_VC_VERSION' ) ) {
           global $wpdb;
           $formsValues = array();
           $table_name = $wpdb->prefix . "cbb_banners";
           $banners = $wpdb->get_results("SELECT id,title FROM $table_name ORDER BY id ASC");
           foreach ($banners as $banner) {
              $bannersValues[] = $banner->id;
           }

         vc_map( array(
           "name" => __('Creative banner', 'cbb'),
           "base" => "creative_banner",
           "category" => 'Content',
           "icon" => 'icon_cbb_banner',
           "params" => array(
              array(
                 "type" => "dropdown",
                 "holder" => "div",
                 "class" => "",
                 "heading" => __("Banner ID", 'cbb'),
                 "param_name" => "banner_id",
                 "value"       => $bannersValues,
                 "std"         => "1",
                 "description" => __("Select a banner","cbb")
              )
           )
        ));
       }
    }


    /**
     * Add menu to admin
     * @return void
     */
    public function add_menu_item()
    {
        add_menu_page(__("Creative Banner", 'cbb'), __("Banners Builder", 'cbb'), 'manage_options', 'cbb_menu', array($this, 'view_edit_cbb'), 'dashicons-art');
        $menuSlag = 'cbb_menu';
    }

    public function getSettings()
    {
        global $wpdb;
        $table_name = $wpdb->prefix . "cbb_settings";
        $settings = $wpdb->get_results("SELECT * FROM $table_name WHERE id=1 LIMIT 1");
        $settings = $settings[0];
        return $settings;
    }

    /* Ajax : Upload a picture */
    public function upload_picture(){
        $cat = $_POST['importFileTag'];
        $ext = strtolower(substr($_FILES['importFile']['name'],-4));
        if($ext == ".jpg" || $ext == ".png") {
            $filename = date('Ymdhis').$ext;
            if (@move_uploaded_file($_FILES['importFile']['tmp_name'], trailingslashit($this->parent->dir).'assets/picsLibrary/'.$filename)) {
                global $wpdb;
                $table_name = $wpdb->prefix . "cbb_library";
                $wpdb->insert($table_name, array('type' => $_POST['type'],'file'=>$filename,'parentFile'=>$_POST['parentFile'],'category'=>$cat));
                echo $this->parent->assets_url.'picsLibrary/'.$filename;
            } else {
                echo 'error move';
            }
        } else {
            echo 'error';
        }     
         die();
    }
    
    /* Ajax : get sprites list */
    public function getSprites(){
        global $wpdb;
        $rep = '';
        $file = $_POST['file'];
        $table_name = $wpdb->prefix . "cbb_library";
        $sprites = $wpdb->get_results('SELECT * FROM '.$table_name.' WHERE type="sprite" AND parentFile="'.$file.'"');
        foreach ($sprites as $sprite) {
            $rep .= '<a href="javascript:" data-file="'.$this->parent->assets_url.'picsLibrary/'.$sprite->file.'"><img src="'.$this->parent->assets_url.'picsLibrary/'.$sprite->file.'"></a>';
        }
        echo $rep;
        die();
    }
    
    /* Ajax : save object */
    public function saveObject(){
        global $wpdb;
        $file = $_POST['file'];
        
        $file = substr($file, strrpos($file, '/')+1);
        echo $file;
        $animation = $_POST['animation'];
        $table_name = $wpdb->prefix . "cbb_library";
        $wpdb->update($table_name, array('animation'=>$animation), array('file' => $file,'type'=>'objects'));
        die();
    }
    
    /* Ajax : remove picture */
    public function delPic(){
        global $wpdb;
        $type = $_POST['type'];
        $file = $_POST['file'];
        
        $table_name = $wpdb->prefix . "cbb_library";
        $wpdb->delete($table_name, array('file' => $file,'type'=>$type));   
        if (substr($file,0,2) == '20'){
            if (file_exists(trailingslashit($this->parent->dir).'assets/picsLibrary/'.$file)){
                unlink(trailingslashit($this->parent->dir).'assets/picsLibrary/'.$file);
            }
        
            $table_name = $wpdb->prefix . "cbb_library";
            $sprites = $wpdb->get_results("SELECT * FROM $table_name WHERE type='sprite' AND parentFile='".$this->parent->assets_url.'picsLibrary/'.$file."'");
            foreach ($sprites as $sprite) {
                if (substr($sprite->file,0,2) == '20'&& file_exists(trailingslashit($this->parent->dir).'assets/picsLibrary/'.$sprite->file)){
                    unlink(trailingslashit($this->parent->dir).'assets/picsLibrary/'.$sprite->file);
                }
            }
        }
        $wpdb->delete($table_name, array('parentFile' => $file,'type'=>'sprite'));   
        
        die();
        
    }
    
    /* Ajax : change domElement of banner */
    public function saveDomElement(){
        global $wpdb;
        $bannerID = $_POST['bannerID'];
        $domElement = $_POST['domElement'];
        
        $table_name = $wpdb->prefix . "cbb_banners";
        $wpdb->update($table_name, array('domElement'=>$domElement), array('id' => $bannerID));  
        
    }

    /*
     * Main view
     */
    public function view_edit_cbb()
    {
        global $wpdb;
        $settings = $this->getSettings();
        

        echo '<div id="cbb_loader"></div>';
        echo '<div id="cbb_bootstraped" class="cbb_bootstraped cbb_panel">';
        
        
        echo '<div id="cbb_formWrapper" >';

        echo '<div class="cbb_winHeader col-md-12 palette palette-turquoise">
               <span class="glyphicon glyphicon-th-list"></span>' . __('Creative Banners Builder', 'cbb') . '';
        echo '<div class="btn-toolbar">';
        echo '<div class="btn-group">';
        echo '</div>';
        echo '</div>'; // eof toolbar
        echo '</div>'; // eof cbb_winHeader
        echo '<div class="clearfix"></div>';


        echo '<div id="cbb_panelSettings">';
        echo '<div class="container-fluid cbb_container" style="max-width: 90%;margin: 0 auto;margin-top: 18px;">';
        echo '</div>'; // eof container
        echo '</div>'; // eof cbb_panelSettings

        echo '<div class="clearfix"></div>';

        echo '<div id="cbb_panelBannersList">';
        echo '<div class="container-fluid cbb_container" style="max-width: 90%;margin: 0 auto;margin-top: 18px;">';
        echo '<div class="col-md-12">';

        echo '<div role="tabpanel">';
        echo '<ul class="nav nav-tabs" role="tablist" >
                <li role="presentation" class="active" ><a href="#cbb_bannersTabGeneral" aria-controls="general" role="tab" data-toggle="tab" ><span class="glyphicon glyphicon-th-list" ></span > ' . __('Banners List', 'cbb') . ' </a ></li >
                </ul >';
        echo '<div class="tab-content" >';
        echo '<div role="tabpanel" class="tab-pane active" id="cbb_bannersTabGeneral" >';

        echo '<p style="text-align: right; margin-top: 18px;">
            <a href="javascript:" style="margin-right: 12px;" onclick="cbb_addBanner();" class="btn btn-primary"><span class="glyphicon glyphicon-plus"></span>' . __('Add a new Banner', 'cbb') . ' </a>
            <a href="javascript:" style="margin-right: 12px;" onclick=" jQuery(\'#cbb_winImport\').modal(\'show\');" class="btn btn-warning"><span class="glyphicon glyphicon-import"></span>' . __('Import banners', 'cbb') . ' </a>
            <a href="javascript:" onclick="cbb_exportBanners();" class="btn btn-default"><span class="glyphicon glyphicon-export"></span>' . __('Export all banners', 'cbb') . ' </a>
         </p>';
        echo '<table class="table">';
        echo '<thead>';
        echo '<th>' . __('Banner title', 'cbb') . '</th>';
        echo '<th>' . __('Integration', 'cbb') . '</th>';
        echo '<th>' . __('Actions', 'cbb') . '</th>';
        echo '</thead>';
        echo '<tbody>';
        $table_name = $wpdb->prefix . "cbb_banners";
        $banners = $wpdb->get_results("SELECT * FROM $table_name ORDER BY id ASC");
        foreach ($banners as $banner) {
            echo '<tr>';
            echo '<td><a href="javascript:" onclick="cbb_editBannerName(this);">' . $banner->title . '</a><span  style="display:none;"><input type="text" style="max-width: 160px;display: inline-block;margin-right: 8px;" class="form-control" value="' . $banner->title . '"/><a href="javascript:" onclick="cbb_changeBannerName(jQuery(this).prev(\'input\').get(0),' . $banner->id . ');" class="btn btn-primary btn-circle"><span class="glyphicon glyphicon-check"></span></a></span></td>';
            echo '<td><a href="javascript:" onclick="cbb_showShortcodeWin('.$banner->id.',\''.$banner->domElement.'\');" class="btn btn-info btn-circle"><span class="glyphicon glyphicon-info-sign"></span></a><code>[creative_banner banner_id="'.$banner->id.'"]</code></td>';
            echo '<td>';
            echo '<a href="javascript:" onclick="cbb_loadBanner(' . $banner->id . ');" class="btn btn-primary btn-circle"><span class="glyphicon glyphicon-pencil"></span></a>';
            echo '<a href="javascript:" onclick="cbb_duplicateBanner(' . $banner->id . ');" class="btn btn-default btn-circle"><span class="glyphicon glyphicon-duplicate"></span></a>';
            echo '<a href="javascript:" onclick="cbb_removeBanner(' . $banner->id . ');" class="btn btn-danger btn-circle"><span class="glyphicon glyphicon-trash"></span></a>';
            echo '</td>';
            echo '</tr>';
        }
        echo '</tbody>';
        echo '</table>';



        echo '</div>'; // eof tab-content
        echo '</div>'; // eof cbb_bannersTabGeneral
        echo '</div>'; // eof tabpanel


        echo '</div>'; // eof col-md-12
        echo '</div>'; // eof container
        echo '</div>'; // eof cbb_panelBannersList


        echo '<div id="cbb_panelPreview">';
        echo '<div class="cbb_winHeader col-md-12 palette palette-turquoise">
               <span class="glyphicon glyphicon-pencil"></span>' . __('Edit a banner', 'cbb') . '';
        echo '<div class="btn-toolbar">';
        echo '<div class="btn-group">';
        echo '<a class="btn btn-primary" href="javascript:" onclick="cbb_closeBanner();" data-toggle="tooltip" title="'.__('Return to the banners list','cbb').'"><span class="glyphicon glyphicon-remove"></span></a>';
        echo '</div>';
        echo '</div>'; // eof toolbar
        echo '</div>'; // eof cbb_winHeader
        echo '<div class="clearfix"></div>';
        echo '<div class="clearfix"></div>';

      echo '<div id="cbb_bannerToolbar">
               <div class="cbb_bannerBloc cbb_selected"><a href="javascript:" data-btntype="floor" id="cbb_elementFloor" onclick="cbb_detailsChange(\'floor\');"></a>'.__('Floor','cbb').'</div>
               <div class="cbb_bannerBloc"><a href="javascript:" data-btntype="background" id="cbb_elementBackground" onclick="cbb_detailsChange(\'background\');"></a>'.__('Background','cbb').'</div>
               <div class="cbb_bannerBloc"><a href="javascript:" data-btntype="ceiling" id="cbb_elementCeiling" onclick="cbb_detailsChange(\'ceiling\');"></a>'.__('Ceiling','cbb').'</div>
               <div class="cbb_bannerBloc"><a href="javascript:" data-btntype="walls" id="cbb_elementWalls" onclick="cbb_detailsChange(\'walls\');"></a>'.__('Walls','cbb').'</div>
               <div class="cbb_bannerBloc"><a href="javascript:" data-btntype="objects" id="cbb_elementObjects" onclick="cbb_detailsChange(\'objects\');"></a>'.__('Objects','cbb').'</div>
            </div>';
        echo '<div id="cbb_bannerContainer">'
                .'<canvas id="cbb_bannerCanvas" width="980" height="280"></canvas>'
                .'<canvas id="cbb_bordersCanvas" width="980" height="280"></canvas>'
                .'<canvas id="cbb_canvas3D" width="980" height="280"></canvas>'
                .'<canvas id="cbb_tmpCanvas"></canvas>'
                .'<div id="cbb_borderBottom"></div>'
                .'<div id="cbb_borderTop"></div>'
                .'<div id="cbb_borderLeft"></div>'
                .'<div id="cbb_borderRight"></div>'
         . '</div>';
        
        
        echo '<div id="cbb_details">';        
        echo '<div id="cbb_detailsFloor" data-type="floor">';
        echo '<div id="cbb_objectsHeader" class="cbb_winHeader col-md-12 palette palette-concrete">
               <span class="glyphicon glyphicon-th-large"></span>' . __('Floor', 'cbb') . '';
        echo '<div class="btn-toolbar">';
        echo '<div class="btn-group">';        
        echo '</div>';
        echo '</div>'; // eof toolbar
        echo '</div>'; // eof cbb_winHeader
        echo '<div class="clearfix"></div>';

        echo '<div>
                <div class="col-md-4">
                    <div class="form-group">
                        <label>'.__('Color','cbb').' :</label>
                        <input name="color" type="text" class="cbb_colorPicker" value="#FFFFFF" />
                    </div>                    
                     <div class="form-group">
                        <label>'.__('Height','cbb').' :</label>
                        <div name="height" class="cbb_slider" data-min="0" data-max="50" data-value="28"></div>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="form-group">
                        <label>'.__('Depth color','cbb').' :</label>
                        <input name="colorDepth" type="text" class="cbb_colorPicker" value="#95a5a6" />
                    </div>
                    <div class="form-group">
                        <label>'.__('Depth color opacity','cbb').' :</label>
                        <div name="colorDepthAlpha" class="cbb_slider" data-min="0" data-max="100" data-value="50" data-lessone="true"></div>
                    </div>
                     <div class="form-group">
                        <label>'.__('Depth','cbb').' :</label>
                        <div name="depth" class="cbb_slider" data-min="0" data-max="100" data-value="50"></div>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="form-group cbb_picsListGroup">
                        <label>'.__('Texture','cbb').' :</label>
                            <a href="http://graphicriver.net/search?utf8=%E2%9C%93&term=textures&view=grid&sort=sales&date=&ref=loopus&category=textures" target="_blank" class="btn btn-info" ><span class="glyphicon glyphicon-shopping-cart"></span>'.__('Buy more textures','cbb').'</a>
                            <a href="javascript:" class="btn btn-warning "><span class="glyphicon glyphicon-cloud-upload"></span>'.__('Upload a texture','cbb').'</a>
                        <div id="cbb_floorPicsList" class="cbb_picsListContainer">
                            <div class="cbb_picsList">';
                            $table_name = $wpdb->prefix . "cbb_library";
                            $pictures = $wpdb->get_results('SELECT * FROM '.$table_name.' WHERE type="floor" ORDER BY id ASC');
                            echo '<a href="javascript:" class="cbb_noPic" data-file="'.$this->parent->assets_url.'picsLibrary/texture_blank.png"></a>';
                            foreach ($pictures as $picture) {
                             //   echo '<a href="javascript:" style="background-image:url('.$this->parent->assets_url.'picsLibrary/'.$picture->file.')" data-file="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'"></a>';
                              echo '<a href="javascript:" data-file="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'"><img src="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'" /></a>';

                            }
                       echo '</div>
                        </div>
                    </div>
                </div>
                <div class="clearfix"></div>
                <div class="col-md-12"><p class="text-center"></p></div>
            </div>
        ';
        echo '</div>'; // eof cbb_detailsFloor
        
        
        echo '<div id="cbb_detailsCeiling" data-type="ceiling">';
        echo '<div id="cbb_objectsHeader" class="cbb_winHeader col-md-12 palette palette-concrete">
               <span class="glyphicon glyphicon-th-large"></span>' . __('Ceiling', 'cbb') . '';
        echo '<div class="btn-toolbar">';
        echo '<div class="btn-group">';        
        echo '</div>';
        echo '</div>'; // eof toolbar
        echo '</div>'; // eof cbb_winHeader
        echo '<div class="clearfix"></div>';

        echo '<div>
                <div class="col-md-4">
                    <div class="form-group">
                        <label>'.__('Color','cbb').' :</label>
                        <input name="color" type="text" class="cbb_colorPicker" value="#FFFFFF" />
                    </div>
                     <div class="form-group">
                        <label>'.__('Height','cbb').' :</label>
                        <div name="height" class="cbb_slider" data-min="0" data-max="50" data-value="28"></div>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="form-group">
                        <label>'.__('Depth color','cbb').' :</label>
                        <input name="colorDepth" type="text" class="cbb_colorPicker" value="#95a5a6" />
                    </div>
                    <div class="form-group">
                        <label>'.__('Depth color opacity','cbb').' :</label>
                        <div name="colorDepthAlpha" class="cbb_slider" data-min="0" data-max="100" data-value="50" data-lessone="true"></div>
                    </div>
                     <div class="form-group">
                        <label>'.__('Depth','cbb').' :</label>
                        <div name="depth" class="cbb_slider" data-min="0" data-max="100" data-value="50"></div>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="form-group cbb_picsListGroup">
                        <label>'.__('Texture','cbb').' :</label>
                            <a href="http://graphicriver.net/search?utf8=%E2%9C%93&term=textures&view=grid&sort=sales&date=&ref=loopus&category=textures" target="_blank" class="btn btn-info" ><span class="glyphicon glyphicon-shopping-cart"></span>'.__('Buy more textures','cbb').'</a>
                            <a href="javascript:" class="btn btn-warning "><span class="glyphicon glyphicon-cloud-upload"></span>'.__('Upload a texture','cbb').'</a>
                        <input type="hidden" name="texture"/>
                        <div id="cbb_floorPicsList" class="cbb_picsListContainer">
                            <div class="cbb_picsList">';
                            $table_name = $wpdb->prefix . "cbb_library";
                            $pictures = $wpdb->get_results('SELECT * FROM '.$table_name.' WHERE type="ceiling" ORDER BY id ASC');
                            echo '<a href="javascript:" class="cbb_noPic" data-file="'.$this->parent->assets_url.'picsLibrary/texture_blank.png"></a>';
                            foreach ($pictures as $picture) {
                             //   echo '<a href="javascript:" style="background-image:url('.$this->parent->assets_url.'picsLibrary/'.$picture->file.')" data-file="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'"></a>';
                                echo '<a href="javascript:" data-file="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'"><img src="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'" /></a>';
                                
                            }
                       echo '</div>
                        </div>
                    </div>
                </div>
                <div class="clearfix"></div>
                <div class="col-md-12"><p class="text-center"></p></div>
            </div>
        ';
        echo '</div>'; // eof cbb_detailsCeiling
        
        
        echo '<div id="cbb_detailsWalls" data-type="walls">';
        echo '<div id="cbb_objectsHeader" class="cbb_winHeader col-md-12 palette palette-concrete">
               <span class="glyphicon glyphicon-th-large"></span>' . __('Walls', 'cbb') . '';
        echo '<div class="btn-toolbar">';
        echo '<div class="btn-group">';        
        echo '</div>';
        echo '</div>'; // eof toolbar
        echo '</div>'; // eof cbb_winHeader
        echo '<div class="clearfix"></div>';

        echo '<div>
                <div class="col-md-4">
                    <div class="form-group">
                        <label>'.__('Color','cbb').' :</label>
                        <input name="color" type="text" class="cbb_colorPicker" value="#FFFFFF" />
                    </div>
                     <div class="form-group">
                        <label>'.__('Width','cbb').' :</label>
                        <div name="width" class="cbb_slider" data-min="0" data-max="50" data-value="28"></div>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="form-group">
                        <label>'.__('Depth color','cbb').' :</label>
                        <input name="colorDepth" type="text" class="cbb_colorPicker" value="#bdc3c7" />
                    </div>
                    <div class="form-group">
                        <label>'.__('Depth color opacity','cbb').' :</label>
                        <div name="colorDepthAlpha" class="cbb_slider" data-min="0" data-max="100" data-value="50" data-lessone="true"></div>
                    </div>
                     <div class="form-group">
                        <label>'.__('Depth','cbb').' :</label>
                        <div name="depth" class="cbb_slider" data-min="0" data-max="100" data-value="50"></div>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="form-group cbb_picsListGroup">
                        <label>'.__('Texture','cbb').' :</label>
                            <a href="http://graphicriver.net/search?utf8=%E2%9C%93&term=textures&view=grid&sort=sales&date=&ref=loopus&category=textures" target="_blank" class="btn btn-info" ><span class="glyphicon glyphicon-shopping-cart"></span>'.__('Buy more textures','cbb').'</a>
                            <a href="javascript:" class="btn btn-warning"><span class="glyphicon glyphicon-cloud-upload"></span>'.__('Upload a texture','cbb').'</a>
                        <div id="cbb_floorPicsList" class="cbb_picsListContainer">
                            <div class="cbb_picsList">';
                            $table_name = $wpdb->prefix . "cbb_library";
                            $pictures = $wpdb->get_results('SELECT * FROM '.$table_name.' WHERE type="walls" ORDER BY id ASC');
                            echo '<a href="javascript:" class="cbb_noPic" data-file="'.$this->parent->assets_url.'picsLibrary/texture_blank.png"></a>';
                            foreach ($pictures as $picture) {
                               // echo '<a href="javascript:" style="background-image:url('.$this->parent->assets_url.'picsLibrary/'.$picture->file.')" data-file="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'"></a>';
                                echo '<a href="javascript:" data-file="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'"><img src="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'" /></a>';

                            }
                       echo '</div>
                        </div>
                    </div>
                </div>
                <div class="clearfix"></div>
                <div class="col-md-12"><p class="text-center"></p></div>
            </div>
        ';
        echo '</div>'; // eof cbb_detailsWalls
        
        
        echo '<div id="cbb_detailsBackground" data-type="background">';
        echo '<div id="cbb_objectsHeader" class="cbb_winHeader col-md-12 palette palette-concrete">
               <span class="glyphicon glyphicon-th-large"></span>' . __('Background', 'cbb') . '';
        echo '<div class="btn-toolbar">';
        echo '<div class="btn-group">';        
        echo '</div>';
        echo '</div>'; // eof toolbar
        echo '</div>'; // eof cbb_winHeader
        echo '<div class="clearfix"></div>';

        echo '<div>
                <div class="col-md-4">
                    <div class="form-group">
                        <label>'.__('Color','cbb').' :</label>
                        <input name="color" type="text" class="cbb_colorPicker" value="#ebebeb" />
                    </div>
                    <div class="form-group">
                        <label>'.__('Color opacity','cbb').' :</label>
                        <div name="colorAlpha" class="cbb_slider" data-min="0" data-max="100" data-value="50" data-lessone="true"></div>
                    </div>
                </div>
                <div class="col-md-8">
                    <div class="form-group cbb_picsListGroup">
                        <label>'.__('Texture','cbb').' :</label>
                            <a href="http://graphicriver.net/search?utf8=%E2%9C%93&term=textures&view=grid&sort=sales&date=&ref=loopus&category=textures" target="_blank" class="btn btn-info" ><span class="glyphicon glyphicon-shopping-cart"></span>'.__('Buy more textures','cbb').'</a>
                            <a href="javascript:" class="btn btn-warning "><span class="glyphicon glyphicon-cloud-upload"></span>'.__('Upload a texture','cbb').'</a>
                        <div id="cbb_backgroundPicsList" class="cbb_picsListContainer">
                            <div class="cbb_picsList">';
                            $table_name = $wpdb->prefix . "cbb_library";
                            $pictures = $wpdb->get_results('SELECT * FROM '.$table_name.' WHERE type="background" ORDER BY id ASC');
                            echo '<a href="javascript:" class="cbb_noPic" data-file="'.$this->parent->assets_url.'picsLibrary/texture_blank.png"></a>';
                            foreach ($pictures as $picture) {
                               // echo '<a href="javascript:" style="background-image:url('.$this->parent->assets_url.'picsLibrary/'.$picture->file.')" data-file="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'"></a>';
                                 echo '<a href="javascript:" data-file="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'"><img src="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'" /></a>';

                            }
                       echo '</div>
                        </div>
                    </div>
                </div>
                <div class="clearfix"></div>
                <div class="col-md-12"><p class="text-center"></p></div>
            </div>
        ';
        echo '</div>'; // eof cbb_detailsBackground
        
        
        echo '<div id="cbb_detailsObjects" data-type="objects">';
        echo '<div id="cbb_objectsHeader" class="cbb_winHeader col-md-12 palette palette-concrete">
               <span class="glyphicon glyphicon-th-large"></span>' . __('Objects library', 'cbb');
        echo '<div class="btn-toolbar">';
        echo '<div class="btn-group">';
        
        
        echo '</div>';
        echo '</div>'; // eof toolbar
        echo '</div>'; // eof cbb_winHeader
        echo '<div class="clearfix"></div>';

        echo '<div>           
            <div id="cbb_objectsContainer" class="col-md-12">
                <div id="cbb_objectsDefault">
                    <div class="form-group cbb_picsListGroup">
                        <label style="width: auto;">'.__('Picture','cbb').' :</label>
                        <div class="cbb_tagsContainer">';        
                            $table_name = $wpdb->prefix . "cbb_library";
                            $tags = $wpdb->get_results('SELECT DISTINCT category,type FROM '.$table_name.' WHERE type="objects" ORDER BY category ASC');
                            echo '<a href="javascript:" onclick="cbb_filterCat(\'\')"><span class="label label-primary">'.__('All','cbb').'</span></a>';
                            foreach ($tags as $tag) {                        
                                echo '<a href="javascript:" data-tag="'.$tag->category.'" onclick="cbb_filterCat(\''.$tag->category.'\')"><span class="label label-primary"">'.ucfirst($tag->category).'</span></a>';
                            }                        
                        echo'</div>
                        <a href="http://graphicriver.net/search?utf8=%E2%9C%93&term=furnitures&view=grid&sort=trending&ref=loopus&date=&category=vectors" target="_blank" class="btn btn-info" ><span class="glyphicon glyphicon-shopping-cart"></span>'.__('Buy more objects','cbb').'</a>
                        <a href="javascript:" class="btn btn-warning " style="float: right;"><span class="glyphicon glyphicon-cloud-upload"></span>'.__('Upload a picture','cbb').'</a>
                        <div id="cbb_backgroundPicsList" class="cbb_picsListContainer" style="margin-top: 4px;">
                            <div class="cbb_picsList" style="padding-top:4px;">';
                            $table_name = $wpdb->prefix . "cbb_library";
                            $pictures = $wpdb->get_results('SELECT * FROM '.$table_name.' WHERE type="objects" ORDER BY id ASC');
                            echo '<a href="javascript:" class="cbb_noPic" data-file=""></a>';
                            foreach ($pictures as $picture) {
                                 $animated = '';
                                if($picture->animation != ""){
                                    $animated = '<span class="badge"><span class="glyphicon glyphicon-play-circle"></span></span>';
                                }
                                echo '<a href="javascript:" data-cat="'.$picture->category.'" data-file="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'" data-animation="'.$picture->animation.'"><img src="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'"  />'.$animated.'</a>';
                            }
                       echo '</div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="clearfix"></div>
          </div>
        ';
        echo '</div>'; // eof cbb_detailsObjects
        
        
        echo '<div id="cbb_detailsObjectsEdit" data-type="objects">';
        echo '<div id="cbb_objectsHeader" class="cbb_winHeader col-md-12 palette palette-concrete">
               <span class="glyphicon glyphicon-th-large"></span>' . __('Edit an object', 'cbb');
        echo '<div class="btn-toolbar">';
        echo '<div class="btn-group">';
        
        echo '<a href="javascript:" onclick="cbb_removeObject();" style="margin-right: 6px;" class="btn btn-danger btn-circle"><span class="glyphicon glyphicon-trash" style="margin-right:0px;"></span></a>';
        
        echo '</div>';
        echo '</div>'; // eof toolbar
        echo '</div>'; // eof cbb_winHeader
        echo '<div class="clearfix"></div>';
        echo ' <div class="col-md-4">    
                 <textarea name="animation" style="display:none;"></textarea> 
                <div class="form-group">
                    <label>'.__('Sort order','cbb').' :</label>
                   <div name="indexObject" class="cbb_slider" data-min="0" data-max="1" data-value="0"></div>
                </div>    
                <div class="form-group">  
                   <label>'.__('Type of object','cbb').' :</label>
                   <select class="form-control" name="type">
                        <option value="">'.__('Simple','cbb').'</option>
                        <option value="animated">'.__('Animated','cbb').'</option>
                        <option value="3d">'.__('3D Object','cbb').'</option>                        
                    </select>
                </div>   
               
                <div class="form-group">
                   <label>'.__('Animation type','cbb').' :</label>
                   <select name="animationType"class="form-control">
                      <option value="loop">'.__('Loop','cbb').'</option>
                      <option value="hover">'.__('Once on mouse over','cbb').'</option>
                      <option value="loopHover">'.__('Loop on mouse over','cbb').'</option>
                   </select>
                </div> 
                <div class="form-group">
                   <label></label>
                   <a href="javascript:" id="cbb_btnEditAnim" onclick="cbb_editAnimation();" class="btn btn-warning"><span class="glyphicon glyphicon-play-circle"></span>'.__('Animation','cbb').'</a>   
                </div>                
               ';
               
            echo '</div>    
            <div class="col-md-4">   
                <div class="form-group">
                   <label>'.__('Depth','cbb').' :</label>
                   <div name="depthObject" class="cbb_slider" data-min="0" data-max="30" data-value="0"></div>
               </div>       
                <div class="form-group">
                    <label>'.__('Depth color','cbb').' :</label>
                    <input name="depthColor" type="text" class="cbb_colorPicker" value="#FFFFFF" />
                </div> 
                <div class="form-group">
                   <label>'.__('Open url on click','cbb').' :</label>
                   <input type="text" name="urlClick" class="form-control" placeholder="http://www..." data-tooltip="'.__('To use javascript code, start the code by javascript:','cbb').'"/>
               </div>';    
                if (is_plugin_active('AIAssistant/aiAssistant.php')) {
                   echo ' <div class="form-group">
                            <label style="line-height: 18px;">'.__('Use this object as A.I Assistant','cbb').' :</label>
                            <input type="checkbox" name="isAIAssistant" data-toggle="switch" />
                        </div>';
               }
            echo '
            </div> 
            <div class="col-md-4">  
                <div class="form-group">
                    <label>'.__('Enable Shadow','cbb').' :</label>
                    <input type="checkbox" name="shadowEnabled" data-toggle="switch" />
                </div>     
                <div class="form-group">
                    <label>'.__('Shadow opacity','cbb').' :</label>
                   <div name="shadowAlpha" class="cbb_slider" data-min="0" data-max="100" data-value="50" data-lessone="true"></div>
                </div>    
                <div class="form-group">
                    <label>'.__('Shadow position','cbb').' :</label>
                   <div name="shadowPosition" class="cbb_slider" data-min="-80" data-max="80" data-value="0"></div>
                </div>    
                <div class="form-group" style="display: none;">
                   <label>'.__('Shadow position top','cbb').' :</label>
                   <div name="shadowPositionY" class="cbb_slider" data-min="-80" data-max="80" data-value="0"></div>
                </div>   
            </div>     
        
            <div class="clearfix"></div>
        ';
        echo '</div>'; // eof cbb_detailsObjects
        
        echo '<p class="text-center"><a href="javascript:" id="cbb_btnSaveBanner" onclick="cbb_saveBanner(false);" class="btn btn-lg btn-primary"><span class="glyphicon glyphicon-floppy-disk"></span>'.__('Save the banner','cbb').'</a></p>';

        echo '</div>'; // eof cbb_details
        
         echo '
        <!-- Modal -->
        <div class="modal fade" id="modal_animation" tabindex="-1" role="dialog" aria-hidden="true" data-type="sprite">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">              
                ' . __('Edit an animation', 'cbb') . '
              </div>
              <div class="modal-body">
                <div id="cbb_animList">
                    <div class="cbb_animRow" data-default="false">
                        <div class="container-fluid">
                            <div class="col-md-2">
                                <div class="cbb_animObjectImgContainer">
                                    <div class="cbb_animObjectImg"></div> 
                                </div>
                            </div>
                            <div class="col-md-5">
                                <div class="form-group">
                                    <label>'.__('Duration (in ms)','cbb').'</label><br/>
                                    <div name="duration" class="cbb_slider" data-min="0" data-max="10000" data-value="0" ></div>
                                </div>
                            </div>
                            <div class="col-md-5">
                                <div class="form-group">
                                    <label>'.__('Fade In duration (in ms)','cbb').'</label><br/>
                                    <div name="durationFx" class="cbb_slider" data-min="0" data-max="5000" data-value="0" ></div>
                                </div>
                            </div>
                        </div>
                        <div class="clearfix"></div>              
                    </div>
                    <div class="cbb_animRow">     
                        <input type="file" name="file" />                  
                        
                        <div class="container-fluid">
                            <div class="col-md-2">
                                <div class="cbb_animObjectImgContainer">
                                    <div class="cbb_animObjectImg"></div>     
                                </div>
                            </div>
                            <div class="col-md-5">
                                <div class="form-group">
                                    <label>'.__('Duration (in ms)','cbb').'</label><br/>
                                    <div name="duration" class="cbb_slider" data-min="0" data-max="10000" data-value="0" ></div>
                                </div>
                            </div>
                            <div class="col-md-5">
                                <div class="form-group">
                                    <label>'.__('Fade In duration (in ms)','cbb').'</label><br/>
                                    <div name="durationFx" class="cbb_slider" data-min="0" data-max="5000" data-value="0" ></div>
                                </div>
                            </div>
                        </div>
                        <div class="clearfix"></div>
                    </div>
                </div>
                <div><a href="javascript:" onclick="cbb_addAnimationImage();" class="btn btn-info"><span class="glyphicon glyphicon-plus"></span>'.__('Add a picture','cbb').'</a></div>
           
                    <div class="form-group cbb_picsListGroup cbb_hidden">
                        <label>'.__('Sprite','cbb').' :</label>
                            <a href="javascript:" class="btn btn-warning "><span class="glyphicon glyphicon-cloud-upload"></span></a>
                            <input type="hidden" name="texture"/>
                            <div id="cbb_spritePicsList" class="cbb_picsListContainer">
                                <div class="cbb_picsList">';
                                $table_name = $wpdb->prefix . "cbb_library";
                                $pictures = $wpdb->get_results('SELECT * FROM '.$table_name.' WHERE type="sprite" ORDER BY id ASC');
                                echo '<a href="javascript:" class="cbb_noPic" data-file=""></a>';
                                foreach ($pictures as $picture) {
                                 //   echo '<a href="javascript:" style="background-image:url('.$this->parent->assets_url.'picsLibrary/'.$picture->file.')" data-file="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'"></a>';
                                    echo '<a href="javascript:" data-file="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'" ><img src="'.$this->parent->assets_url.'picsLibrary/'.$picture->file.'"  />'.$animated.'</a>';

                                }
                           echo '</div>
                            </div>
                    </div>
                    
              </div>
              <div class="modal-footer">
                <a href="javascript:" onclick="cbb_saveAnim();" class="btn btn-primary" data-dismiss="modal" ><span class="glyphicon glyphicon-floppy-disk"></span>' . __('Save', 'cbb') . '</a>
              </div>
            </div>
          </div>
        </div>';
        echo '</div> ';

        
        echo '
        <!-- Modal -->
        <div class="modal fade" id="modal_removeAllSteps" tabindex="-1" role="dialog" aria-hidden="true">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-body">
                ' . __('Are you sure you want to delete all elements ?', 'cbb') . '
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-danger" data-dismiss="modal"  onclick="cbb_removeAllElements();" >' . __('Yes', 'cbb') . '</button>
                <button type="button" class="btn btn-default" data-dismiss="modal" >' . __('No', 'cbb') . '</button>
              </div>
            </div>
          </div>
        </div>';
        echo '</div> ';

        echo '<div id="cbb_winShortcode" class="modal fade ">
                         <div class="modal-dialog">
                           <div class="modal-content">
                             <div class="modal-header">
                               <h4 class="modal-title">'.__('Integration','cbb').'</h4>
                             </div>
                             <div class="modal-body">
                                <div class="col-md-6">
                                    <h4>'.__('Using shortcode','cbb').'</h4>
                                   <p style="margin-bottom: 0px;">'.__('Use this shortcode on a page to display the banner','cbb').' :</p>
                                   <pre class="palette palette-silver" >[creative_banner banner_id="<span data-displayid="1">1</span>"]</pre>
                                   <h4>'.__('Using div','cbb').'</h4>
                                    <p style="margin-bottom: 0px;">'.__('Use this code to integrate the banner directly in the code','cbb').' :</p>
                                   <pre class="palette palette-silver" >&lt;div class="creative_banner" data-id="<span data-displayid="1">1</span>"&gt;
&lt;/div&gt;</pre>
                                   <small>'.__('The best way is to insert the div above <strong>just below the &lt;/header&gt;</strong> tag of the website. In general, you can find it in the <strong>header.php</strong> file of your theme.','cbb').'</small>

                                </div>
                                <div class="col-md-6">
                               
                                <h4>'.__('Replacing a existing element','cbb').'</h4>
                                    <p>
                                       '.__('Enter the id (eg: #theID) or the class (eg: .theClass) of the existing element','cbb').':
                                    </p>
                                        <div class="form-group">
                                            <input name="domElement" type="text" class="form-control" placeholder="#IdOfTheElementHere"/>
                                        </div>
                                        <small>'.__('To see the id or the class of element, do a right click on it and click <strong>Inspect the element</strong>. You will see the id and classes in the inspector of the browser.','cbb').'</small>

                                </div>
                                <div class="clearfix"></div>                                 
                            </div>
                             <div class="modal-footer" style="text-align: center;">
                                 <a href="javascript:" onclick="cbb_saveIntegration();" class="btn btn-primary" data-dismiss="modal"><span class="glyphicon glyphicon-floppy-disk"></span>' . __('Save', 'cbb') . '</a>
                             </div><!-- /.modal-footer -->
                           </div><!-- /.modal-content -->
                         </div><!-- /.modal-dialog -->
                       </div><!-- /.modal -->';

        

                echo '<div id="cbb_winImport" class="modal fade">
                          <div class="modal-dialog">
                            <div class="modal-content">
                              <div class="modal-header">
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                                <h4 class="modal-title">' . __('Import data', 'cbb') . '</h4>
                              </div>
                              <div class="modal-body">
                               <div class="alert alert-danger"><p>' . __('Be carreful : all existing banners will be erased importing new data.', 'cbb') . '</p></div>
                                   <form id="cbb_winImportForm" method="post" enctype="multipart/form-data">
                                       <div class="form-group">
                                        <input type="hidden" name="action" value="cbb_importBanners"/>
                                        <label>' . __('Select the .zip data file', 'cbb') . '</label><input name="importFile" type="file" class="" />
                                       </div>
                                  </form>
                              </div>
                              <div class="modal-footer">
                                <a href="javascript:" class="btn btn-default" data-dismiss="modal"><span class="glyphicon glyphicon-remove"></span>' . __('Cancel', 'cbb') . '</a>
                                <a href="javascript:" class="btn btn-primary" onclick="cbb_importBanners();"><span class="glyphicon glyphicon-floppy-disk"></span>' . __('Import', 'cbb') . '</a>
                            </div>
                            </div><!-- /.modal-content -->
                          </div><!-- /.modal-dialog -->
                        </div><!-- /.modal -->';


        echo '<div id="cbb_winExport" class="modal fade">
                  <div class="modal-dialog">
                    <div class="modal-content">
                      <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <h4 class="modal-title">' . __('Export data', 'cbb') . '</h4>
                      </div>
                      <div class="modal-body">
                        <p style="text-align: center;"><a href="' . $this->parent->assets_url . '../tmp/export_banners.zip" target="_blank" onclick="jQuery(\'#cbb_winExport\').modal(\'hide\');" class="btn btn-primary btn-lg" id="cbb_exportLink"><span class="glyphicon glyphicon-floppy-disk"></span>' . __('Download the exported banners', 'cbb') . '</a></p>
                      </div>
                    </div><!-- /.modal-content -->
                  </div><!-- /.modal-dialog -->
                </div><!-- /.modal -->';
        
        
        echo '<div id="cbb_winSave" class="modal fade">
                  <div class="modal-dialog">
                    <div class="modal-content">
                      <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <h4 class="modal-title">' . __('Save before exiting?', 'cbb') . '</h4>
                      </div>
                      <div class="modal-body">
                        <p style="text-align: center;">'.__('Do you want to save this banner before leaving ?','cbb').'</p>
                      </div>
                        <div class="modal-footer">
                            <a href="javascript:" onclick="cbb_saveBanner(true);" class="btn btn-primary"><span class="glyphicon glyphicon-ok"></span>'.__('Yes','cbb').'</a>
                            <a href="javascript:" onclick="cbb_openBannersList();" class="btn btn-default"><span class="glyphicon glyphicon-remove"></span>'.__('No','cbb').'</a>
                        </div><!-- /.modal-footer -->
                    </div><!-- /.modal-content -->
                  </div><!-- /.modal-dialog -->
                </div><!-- /.modal -->';
        
        echo '<div id="cbb_winScan3D" class="modal fade">
                  <div class="modal-dialog">
                    <div class="modal-content">
                      <div class="modal-header">
                        <button type="button" class="close" onclick="cbb_win3DClose();" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <h4 class="modal-title">' . __('Analyze an object', 'cbb') . '</h4>
                      </div>
                      <div class="modal-body">
                        <p style="text-align: center;">'.__('This object must be analyzed once to give it depth.','cbb').
                            __('Do you want to start the analysis (the speed depends on the complexity of the image) ?','cbb').'</p>
                      </div>
                        <div class="modal-footer">
                            <a href="javascript:" data-dismiss="modal"  onclick="cbb_confirmScan();" class="btn btn-primary"><span class="glyphicon glyphicon-ok"></span>'.__('Yes','cbb').'</a>
                            <a href="javascript:" data-dismiss="modal"  class="btn btn-default" onclick="cbb_win3DClose();"><span class="glyphicon glyphicon-remove"></span>'.__('No','cbb').'</a>
                        </div><!-- /.modal-footer -->
                    </div><!-- /.modal-content -->
                  </div><!-- /.modal-dialog -->
                </div><!-- /.modal -->';
        
        
         echo '<div id="cbb_winUploadImg" class="modal fade">
                  <div class="modal-dialog">
                    <div class="modal-content">
                      <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <h4 class="modal-title">' . __('Upload a picture', 'cbb') . '</h4>
                      </div>
                      <div class="modal-body">
                        <form action="admin.php?page=cbb_menu&action=importPicture" method="post" enctype="multipart/form-data">
                        <input type="hidden" name="action" value="cbb_uploadPicture"/>
                        <input type="hidden" name="type"/>
                        <input type="hidden" name="parentFile"/>
                        <div class="form-group">
                            <label>'.__('Select a picture (.jpg or .png)','cbb').' :</label>
                            <input type="file" class="form-control" name="importFile"/>
                        </div>
                        <div class="form-group">
                            <label>'.__('Enter a tag','cbb').' :</label>
                            <input type="text" class="form-control" name="importFileTag"/>
                        </div>
                      </div>
                        <div class="modal-footer">
                            <a href="javascript:" onclick="cbb_uploadPicture();" class="btn btn-primary"><span class="glyphicon glyphicon-cloud-upload"></span>'.__('Upload','cbb').'</a>
                        </div><!-- /.modal-footer -->   
                    </div><!-- /.modal-content -->                 
                  </div><!-- /.modal-dialog -->
                </div><!-- /.modal -->';

        echo ' </div><!-- /wpe_bootstraped -->';     


    }
    
    /* Ajax : change title of a banner */
    public function changeBannerTitle(){
        $title = $_POST['title'];
        $bannerID = $_POST['bannerID'];
        
        global $wpdb;
        $table_name = $wpdb->prefix . "cbb_banners";
        $wpdb->update($table_name, array('title'=>$title), array('id' => $bannerID));  
        die();
    }

    /*
    * Load admin styles
    */
    function admin_styles()
    {
        if (isset($_GET['page']) && strpos($_GET['page'], 'cbb') !== false) {
            wp_register_style($this->parent->_token . ' - reset', esc_url($this->parent->assets_url) . 'css / reset.css', array(), $this->parent->_version);
            wp_register_style($this->parent->_token . '-bootstrap', esc_url($this->parent->assets_url) . 'css/bootstrap.min.css', array(), $this->parent->_version);
            wp_register_style($this->parent->_token . '-flat-ui', esc_url($this->parent->assets_url) . 'css/flat-ui.css', array(), $this->parent->_version);
            wp_register_style($this->parent->_token . '-colpick', esc_url($this->parent->assets_url) . 'css/colpick.css', array(), $this->parent->_version);
            wp_register_style($this->parent->_token . '-cbb-admin', esc_url($this->parent->assets_url) . 'css/cbb_admin.css', array(), $this->parent->_version);
            wp_enqueue_style($this->parent->_token . '-reset');
            wp_enqueue_style($this->parent->_token . '-bootstrap');
            wp_enqueue_style($this->parent->_token . '-flat-ui');
            wp_enqueue_style($this->parent->_token . '-colpick');
            wp_enqueue_style($this->parent->_token . '-cbb-admin');
        }
        wp_register_style($this->parent->_token . '-cbb-adminGlobal', esc_url($this->parent->assets_url) . 'css/cbb_adminGlobal.css', array(), $this->parent->_version);
        wp_enqueue_style($this->parent->_token . '-cbb-adminGlobal');
    }

    /*
     * Load admin scripts
     */
    function admin_scripts()
    {
        if (isset($_GET['page']) && strpos($_GET['page'], 'cbb') !== false) {

        wp_register_script($this->parent->_token . '-easejs', esc_url($this->parent->assets_url) . 'js/easeljs-0.8.0.min.js', array('jquery'), $this->parent->_version);
        wp_enqueue_script($this->parent->_token . '-easejs');
        wp_register_script($this->parent->_token . '-bootstrap', esc_url($this->parent->assets_url) . 'js/bootstrap.min.js', array('jquery', "jquery-ui-core"), $this->parent->_version);
        wp_enqueue_script($this->parent->_token . '-bootstrap');
        wp_register_script($this->parent->_token . '-bootstrap-switch', esc_url($this->parent->assets_url) . 'js/bootstrap-switch.js', array('jquery', "jquery-ui-core"), $this->parent->_version);
        wp_enqueue_script($this->parent->_token . '-bootstrap-switch');
        wp_register_script($this->parent->_token . '-colpick', esc_url($this->parent->assets_url) . 'js/colpick.js', array('jquery'), $this->parent->_version);
        wp_enqueue_script($this->parent->_token . '-colpick');
        wp_register_script($this->parent->_token . '-cbb-admin', esc_url($this->parent->assets_url) . 'js/cbb_admin.min.js', array("jquery-ui-slider","jquery-ui-draggable", "jquery-ui-droppable", "jquery-ui-resizable", "jquery-ui-sortable", "jquery-ui-datepicker",$this->parent->_token . '-bootstrap-switch',), $this->parent->_version);
        wp_enqueue_script($this->parent->_token . '-cbb-admin');

            $js_data[] = array(
                'assetsUrl' => esc_url($this->parent->assets_url),
                'websiteUrl' => esc_url(get_home_url()),
                'texts' => array(
                    'errorExport' => __('An error occurred during the exportation. Please verify that your server supports the ZipArchive php library ', 'cbb'),
                    'errorImport' => __('An error occurred during the importation. Please verify that your server supports the ZipArchive php library ', 'cbb'),
                    'Yes' => __('Yes', 'cbb'),
                    'No' => __('No', 'cbb')
                )
            );
            wp_localize_script($this->parent->_token . '-cbb-admin', 'cbb_data', $js_data);
        }
    }

  private function jsonRemoveUnicodeSequences($struct)
    {
          return json_encode($struct);
    }

    public function addBanner()
    {
        global $wpdb;
        $table_name = $wpdb->prefix . "cbb_banners";
        $wpdb->insert($table_name, array('title' => 'My new Banner','height'=>380,'content'=>'{\"depthX\":29,\"originalWidth\":1717,\"depth\":50,\"floorColor\":\"#FFFFFF\",\"floorColorDepth\":\"#95a5a6\",\"floorColorDepthAlpha\":50,\"floorHeight\":28,\"ceilingColor\":\"#FFFFFF\",\"ceilingColorDepth\":\"#95a5a6\",\"ceilingColorDepthAlpha\":50,\"ceilingHeight\":28,\"ceilingTexture\":\"\",\"wallsColor\":\"#FFFFFF\",\"wallsColorDepth\":\"#bdc3c7\",\"wallsColorDepthAlpha\":50,\"wallsWidth\":28,\"wallsTexture\":\"\",\"backgroundColor\":\"#ebebeb\",\"backgroundAlpha\":50,\"backgroundTexture\":\"\",\"objects\":[]}'));
        $bannerID = $wpdb->insert_id;

        echo $bannerID;
        die();
    }

    public function duplicateItem(){
        global $wpdb;
        $table_name = $wpdb->prefix . "cbb_items";
        $itemID = $_POST['itemID'];
        $items = $wpdb->get_results("SELECT * FROM $table_name WHERE id=".$itemID);
        $item = $items[0];
        $item->title = $item->title . ' (1)';
        unset($item->id);
        $wpdb->insert($table_name, (array)$item);
        die();
    }

    public function duplicateBanner(){
        global $wpdb;
        $table_name = $wpdb->prefix . "cbb_banners";
        $bannerID = $_POST['bannerID'];

        $table_banners = $wpdb->prefix . "cbb_banners";
        $banners = $wpdb->get_results("SELECT * FROM $table_banners WHERE id=$bannerID LIMIT 1");
        $banner = $banners[0];
        unset($banner->id);
        $banner->title = $banner->title . ' (1)';
        $wpdb->insert($table_banners, (array)$banner);
        $newBannerID = $wpdb->insert_id;       
        die();
    }

    public function saveBanner()
    {
        global $wpdb;
        $table_name = $wpdb->prefix . "cbb_banners";
        $bannerID = $_POST['bannerID'];
        $sqlDatas = array();
       
        $data = $_REQUEST['base64data']; 
        $image = explode('base64,',$data); 
        $imageFile = 'banner_'.$bannerID.'.png';
        file_put_contents(  trailingslashit($this->parent->dir).'assets/depthImgs/'.$imageFile, base64_decode($image[1]));        
       
        $wpdb->update($table_name, array('height'=>$_POST['height'],'content'=>$_POST['content'],'depthImg'=>$imageFile), array('id' => $bannerID));        
        
        echo $bannerID;
        die();
    }

    public
    function removeBanner()
    {
        global $wpdb;
        $bannerID = $_POST['bannerID'];
        $table_name = $wpdb->prefix . "cbb_banners";
        $wpdb->delete($table_name, array('id' => $bannerID));
        $imageFile = 'banner_'.$bannerID.'.png';
        if(file_exists(trailingslashit($this->parent->dir).'assets/depthImgs/'.$imageFile)) {
            unlink(trailingslashit($this->parent->dir).'assets/depthImgs/'.$imageFile);
        }
        die();
    }


    public
    function loadSettings()
    {
        global $wpdb;
        $table_name = $wpdb->prefix . "cbb_settings";
        $settings = $wpdb->get_results("SELECT * FROM $table_name WHERE id=1 LIMIT 1");
        $settings = $settings[0];
        echo json_encode($settings);
        die();
    }


    public function loadBanner()
    {
        global $wpdb;
        $bannerID = $_POST['bannerID'];
        $rep = new stdClass();
        
        $table_name = $wpdb->prefix . "cbb_banners";
        $banners = $wpdb->get_results("SELECT * FROM $table_name WHERE id=" . $bannerID);
        $banner = $banners[0];
        $rep->id = $banner->id;
        $rep->height = $banner->height;
        $rep->content = stripslashes($banner->content);
        echo(json_encode($rep));
        die();
    }

    public function importBanners()
    {
        global $wpdb;
        $displayBanner = true;
        $settings = $this->getSettings();
        $code = $settings->purchaseCode;
        if (isset($_FILES['importFile'])) {
            $error = false;
            if (!is_dir(plugin_dir_path(__FILE__) . '../tmp')) {
                mkdir(plugin_dir_path(__FILE__) . '../tmp');
                chmod(plugin_dir_path(__FILE__) . '../tmp', 0747);
            }
            $target_path = plugin_dir_path(__FILE__) . '../tmp/export_banners.zip';
            if (@move_uploaded_file($_FILES['importFile']['tmp_name'], $target_path)) {

                $upload_dir = wp_upload_dir();
                if (!is_dir($upload_dir['path'])) {
                    mkdir($upload_dir['path']);
                }

                $zip = new ZipArchive;
                $res = $zip->open($target_path);
                if ($res === TRUE) {
                    $zip->extractTo(plugin_dir_path(__FILE__) . '../tmp/');
                    $zip->close();

                    $formsData = array();

                    $jsonfilename = 'export_banners.json';
                    if (!file_exists(plugin_dir_path(__FILE__) . '../tmp/export_banners.json')) {
                        $jsonfilename = 'export_banners';
                    }

                    $file = file_get_contents(plugin_dir_path(__FILE__) . '../tmp/' . $jsonfilename);
                    $dataJson = json_decode($file, true);

                    $table_name = $wpdb->prefix . "cbb_banners";
                    $wpdb->query("TRUNCATE TABLE $table_name");
                    if (array_key_exists('banners', $dataJson)) {
                        foreach ($dataJson['banners'] as $key => $value) {     
                            $value['content'] = str_replace('[picsLib]',addslashes($this->parent->assets_url.'picsLibrary/'), $value['content']);                         
                            $wpdb->insert($table_name, $value);
                        }
                    }
                    $table_name = $wpdb->prefix . "cbb_library";
                    foreach ($dataJson['library'] as $key => $value) { 
                        if (!file_exists(plugin_dir_path(__FILE__) . '../assets/picsLibrary/'.$value['file'])) {
                            if (is_file(plugin_dir_path(__FILE__) . '../tmp/' . $value['file'])) {
                                copy(plugin_dir_path(__FILE__) . '../tmp/' . $value['file'], plugin_dir_path(__FILE__) . '../assets/picsLibrary/'. $value['file']);
                            }
                            unset($value['id']);
                            $wpdb->insert($table_name, $value);
                        }
                    }
                    
                    $files = glob(plugin_dir_path(__FILE__) . '../tmp/*');
                    foreach ($files as $file) {
                        if (is_file($file))
                            unlink($file);
                    }

                } else {
                    $error = true;
                }
            } else {
                $error = true;
            }
            if ($error) {
                echo __('An error occurred during the transfer', 'cbb');
                die();
            } else {
                $displayBanner = false;
                echo 1;
                die();
            }
        }
    }

    public function exportBanners()
    {
        global $wpdb;
        if (!is_dir(plugin_dir_path(__FILE__) . '../tmp')) {
            mkdir(plugin_dir_path(__FILE__) . '../tmp');
            chmod(plugin_dir_path(__FILE__) . '../tmp', 0747);
        }

        $destination = plugin_dir_path(__FILE__) . '../tmp/export_banners.zip';
        if (file_exists($destination)) {
            unlink($destination);
        }
        $zip = new ZipArchive();
        if ($zip->open($destination, ZipArchive::CREATE) !== true) {
            return false;
        }

        $jsonExport = array();

        $table_name = $wpdb->prefix . "cbb_banners";
        $banners = array();
        foreach ($wpdb->get_results("SELECT * FROM $table_name") as $key => $row) {
            $row->content = str_replace(addslashes($this->parent->assets_url.'picsLibrary/'), '[picsLib]', $row->content);
            $banners[] = $row;
        }
        $jsonExport['banners'] = $banners;

       
        $table_name = $wpdb->prefix . "cbb_library";
        $library = array();
        foreach ($wpdb->get_results("SELECT * FROM $table_name") as $key => $row) {
            if ($row->file != "" && $row->isDefault == 0) {                
                $zip->addfile(plugin_dir_path(__FILE__) . '../assets/picsLibrary/' . $row->file, $row->file);
                $row->file = substr($row->file,strrpos($row->file, '/'));
                $library[] = $row;
            }
        }
        $jsonExport['library'] = $library;
        $fp = fopen(plugin_dir_path(__FILE__) . '../tmp/export_banners.json', 'w');
        fwrite($fp, json_encode($jsonExport));
        fclose($fp);

        $zip->addfile(plugin_dir_path(__FILE__) . '../tmp/export_banners.json', 'export_banners.json');
        $zip->close();
        echo '1';
        die();

    }


    /**
     * Main Instance
     *
     *
     * @since 1.0.0
     * @static
     * @return Main instance
     */
    public
    static function instance($parent)
    {
        if (is_null(self::$_instance)) {
            self::$_instance = new self($parent);
        }
        return self::$_instance;
    }

    // End instance()

    /**
     * Cloning is forbidden.
     *
     * @since 1.0.0
     */
    public function __clone()
    {
        _doing_it_wrong(__FUNCTION__, __(''), $this->parent->_version);
    }

// End __clone()

    /**
     * Unserializing instances of this class is forbidden.
     *
     * @since 1.0.0
     */
    public function __wakeup()
    {
        _doing_it_wrong(__FUNCTION__, __(''), $this->parent->_version);
    }

// End __wakeup()
}
